package DraggableListTemplate::CMS;

use strict;

sub list_template {
    my ($cb, $app, $template) = @_;

    return if !$app->blog;

    my $old;
    my $new;

    $old = <<HTML;
<mt:include name="include/header.tmpl">
HTML
    $old = quotemeta($old);

    $new = <<HTML;
<mt:setvarblock name="html_head" append="1">
<style>
.ui-sortable-helper {
    background-color: #fff;
    border: solid 1px #ccc;
}
.ui-sortable-helper .cb {
    width: 2.6em;
}
#index-listing-table .ui-sortable-helper .template-name,
#archive-listing-table .ui-sortable-helper .template-name {
    width: 32%;
}
#module-listing-table .ui-sortable-helper .template-name,
#system-listing-table .ui-sortable-helper .template-name {
    width: 75%;
}
</style>
<script src="<mt:var name="static_uri">plugins/DraggableListTemplate/js/jquery.cookie.js"></script>
</mt:setvarblock>
<mt:include name="include/header.tmpl">
HTML
    $$template =~ s/$old/$new/;

    $old = <<HTML;
<mt:include name="include/footer.tmpl">
HTML
    $old = quotemeta($old);

    $new = <<HTML;
<mt:setvarblock name="jq_js_include" append="1">
    jQuery('tbody').sortable();
    jQuery('tbody').disableSelection();

    var blog_id = '<mt:var name="blog_id">';

    // sort and save cookie
    jQuery('tbody').bind('sortstop', function (e, ui) {
        var id = jQuery(this).parent().attr('id');

        var i = 0;
        var cookie = new Array;
        jQuery('#' + id +' tbody .cb').each(function(){
            jQuery(this).parent().removeClass('odd');
            jQuery(this).parent().removeClass('even');
            if (i % 2 == 1) {
                jQuery(this).parent().addClass('even');
            } else {
                jQuery(this).parent().addClass('odd');
            }
            var number = jQuery(this).find("input").val();
            cookie[i] = number + ":" + i;
            i++;
        });
        jQuery.cookie(blog_id + '_' + id, cookie.join(','));
    });

    // read cookie and initial sort
    var table_name = new Array('index-listing-table', 'archive-listing-table', 'module-listing-table', 'system-listing-table');
    for (var j = 0; j < table_name.length; j++) {
        var index_cookie = jQuery.cookie(blog_id + '_' + table_name[j]);
        if (!index_cookie) {
            continue;
        } else {
            var index_hash = new Array();
            jQuery('#' + table_name[j] + ' tbody tr').each(function(){
                var html = jQuery(this).html();
                var number = jQuery(this).find(".cb input").val();
                index_hash[number] = html;
            });
            var list = index_cookie.split(',');
            var i = 0;
            jQuery('#' + table_name[j] + ' tbody tr').each(function(){

                // no exist cookie
                if (i >= list.length) {
                    for (k = 0, l = i+1; k < index_hash.length; k++) {
                        if (index_hash[k]) {
                            jQuery('#' + table_name[j] + ' tbody tr:nth-child(' + l + ')').each(function(){
                                jQuery(this).html(index_hash[k]);
                                l++;
                            });
                        }
                    }
                    return false;

                // exist cookie
                } else {
                    var val = (list[i].split(':'))[0];
                    jQuery(this).html(index_hash[val]);
                    delete index_hash[val];
                }
                i++;
            });
        }
    }
</mt:setvarblock>
<mt:include name="include/footer.tmpl">
HTML
    $$template =~ s/$old/$new/;

}

sub list_widget {
    my ($cb, $app, $template) = @_;

    return if !$app->blog;

    my $old;
    my $new;

    $old = <<HTML;
<mt:include name="include/header.tmpl">
HTML
    $old = quotemeta($old);

    $new = <<HTML;
<mt:setvarblock name="html_head" append="1">
<style>
.ui-sortable-helper {
    background-color: #fff;
    border: solid 1px #ccc;
}
.ui-sortable-helper .cb {
    width: 2.6em;
}
#template-listing-table .ui-sortable-helper .widgetmanager-name,
#template-listing-table .ui-sortable-helper .widgetmanager-widgets {
    width: 45%;
}
#widget-listing-table .ui-sortable-helper .template-name {
    width: 75%;
}
</style>
<script src="<mt:var name="static_uri">plugins/DraggableListTemplate/js/jquery.cookie.js"></script>
</mt:setvarblock>
<mt:include name="include/header.tmpl">
HTML
    $$template =~ s/$old/$new/;

    $old = <<HTML;
<mt:include name="include/footer.tmpl">
HTML
    $old = quotemeta($old);

    $new = <<HTML;
<mt:setvarblock name="jq_js_include" append="1">
    jQuery('tbody').sortable();
    jQuery('tbody').disableSelection();

    var blog_id = '<mt:var name="blog_id">';

    // sort and save cookie
    jQuery('tbody').bind('sortstop', function (e, ui) {
        var id = jQuery(this).parent().attr('id');

        var i = 0;
        var cookie = new Array;
        jQuery('#' + id +' tbody .cb').each(function(){
            jQuery(this).parent().removeClass('odd');
            jQuery(this).parent().removeClass('even');
            if (i % 2 == 1) {
                jQuery(this).parent().addClass('even');
            } else {
                jQuery(this).parent().addClass('odd');
            }
            var number = jQuery(this).find("input").val();
            cookie[i] = number + ":" + i;
            i++;
        });
        jQuery.cookie(blog_id + '_' + id, cookie.join(','));
    });

    // read cookie and initial sort
    var table_name = new Array('template-listing-table', 'widget-listing-table');
    for (var j = 0; j < table_name.length; j++) {
        var index_cookie = jQuery.cookie(blog_id + '_' + table_name[j]);
        if (!index_cookie) {
            continue;
        } else {
            var index_hash = new Array();
            jQuery('#' + table_name[j] + ' tbody tr').each(function(){
                var html = jQuery(this).html();
                var number = jQuery(this).find(".cb input").val();
                index_hash[number] = html;
            });
            var list = index_cookie.split(',');
            var i = 0;
            jQuery('#' + table_name[j] + ' tbody tr').each(function(){

                // no exist cookie
                if (i >= list.length) {
                    for (k = 0, l = i+1; k < index_hash.length; k++) {
                        if (index_hash[k]) {
                            jQuery('#' + table_name[j] + ' tbody tr:nth-child(' + l + ')').each(function(){
                                jQuery(this).html(index_hash[k]);
                                l++;
                            });
                        }
                    }
                    return false;

                // exist cookie
                } else {
                    var val = (list[i].split(':'))[0];
                    jQuery(this).html(index_hash[val]);
                    delete index_hash[val];
                }
                i++;
            });
        }
    }
</mt:setvarblock>
<mt:include name="include/footer.tmpl">
HTML
    $$template =~ s/$old/$new/;

}

1;
